# source /autox-sd/tools/qnx700/qnxsdp-env.sh s32g 10.10.20.99
# CXX=$(if $(filter $@,depend),g++,q++ -V gcc_ntox86_64_cxx)
ALL_SRC:=$(filter-out hmbdc/app/netmap% hmbdc/app/rnetmap/%,$(ALL_SRC))
BOOST_ROOT:=/opt/boost-qnx
GTEST_ROOT:=/opt/gtest-qnx-1.8.1
ifdef aarch64
CXX=$(if $(filter $@,depend),g++,q++ -V gcc_ntoaarch64le_gpp)
BOOST_ROOT:=$(BOOST_ROOT)-aarch64
GTEST_ROOT:=$(GTEST_ROOT)-aarch64
LINK_FLAGS :=/opt/qnx700/target/qnx7/aarch64le/lib/libsocket.a
else
CXX=$(if $(filter $@,depend),g++,q++ -V gcc_ntox86_64_gpp)
LINK_FLAGS :=/opt/qnx700/target/qnx7/x86_64/lib/libsocket.a
endif

INC_DIRS:=-I. -isystem $(GTEST_ROOT)/include -isystem $(BOOST_ROOT)/include
COMPILE_FLAGS := -D GTEST_HAS_TR1_TUPLE=0 -D_QNX_SOURCE -DHMBDC_NO_EPOLL -include sstream -std=c++1y -Wall -Werror -fPIC $(DEFS) $(INC_DIRS)
ifdef rel
COMPILE_FLAGS += -O3 -D NDEBUG
else
COMPILE_FLAGS += -g
endif
LINK_FLAGS += -fPIC $(GTEST_ROOT)/lib/libgtest_main.a $(GTEST_ROOT)/lib/libgtest.a \
   $(BOOST_ROOT)/lib/libboost_regex.a \
   $(BOOST_ROOT)/lib/libboost_program_options.a \
   $(BOOST_ROOT)/lib/libboost_system.a \
   $(BOOST_ROOT)/lib/libboost_iostreams.a

.PHONY : release_qnx
release_qnx :
	rm -rf libhmbdc*.a hmbdc4-* hmbdc8-* hmbdc16-* hmbdc32-* hmbdc64-* doc *.deb; exit 0
	rpm -q --specfile --changelog hmbdc.spec > ChangeLog.TXT
	make clean depend rel=1
	make _tests -j 8 rel=1
	cp tgt/$(HMBDC_LIB)  .
	mkdir -p hmbdc/app/rmcast/tests/tgt hmbdc/app/netmap/tests/tgt hmbdc/app/rnetmap/tests/tgt
	touch \
		hmbdc/app/rmcast/tests/tgt/Perf__t \
 		hmbdc/app/rmcast/tests/tgt/Pingpong__t \
 		hmbdc/app/rmcast/tests/tgt/Console__t \
		hmbdc/app/netmap/tests/tgt/Perf__t \
		hmbdc/app/netmap/tests/tgt/Pingpong__t \
		hmbdc/app/netmap/tests/tgt/Console__t \
		hmbdc/app/rnetmap/tests/tgt/Perf__t \
		hmbdc/app/rnetmap/tests/tgt/Pingpong__t \
		hmbdc/app/rnetmap/tests/tgt/Console__t
	make packaging tar_package=1
